package rocks.zipcode.io.quiz3.arrays;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {

    private String[][] board;

    public TicTacToe(String[][] board) {
        this.board=board;
    }

    public String[] getRow(Integer value) {
        String[] singleArr =board[value];
        return singleArr;
    }

    public String[] getColumn(Integer value) {
        String[] singleArr = new String[board.length];
        for (int i = 0; i <board.length ; i++) {
            singleArr[i] = board[i][value];
        }
        return singleArr;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {
        String[] row = board[rowIndex];
        for (int i = 0; i <row.length; i++) {
            if (row[i]==row[row.length-1-i]){
                return true;
            }
        }
       return false;
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {
        for(int i = 0; i < board.length; i++){
            for(int j = 1; j < board[i].length; j++){
                if(!board[i][columnIndex].equals(board[i][j])){
                    return true;
                }
            }
        }
        return false;
    }

    public String getWinner() {
        for (int i = 0; i <board.length ; i++) {
            for (int j = 0; j <board.length ; j++) {
                if (board[i][j] == "X"){
                    return "X";
                }
            }
        }
        return "O";
    }
}
