package rocks.zipcode.io.quiz3.generics;

import java.util.Arrays;
import java.util.function.Function;
import java.util.stream.Stream;

/**
 * @author leon on 09/12/2018.
 */
public class ArrayUtility<SomeType> {

    private final SomeType[] array;

    public ArrayUtility(SomeType[] array) {
        this.array = array;
    }

    public SomeType findOddOccurringValue() {
        Arrays.sort(array);
        int nbOccurences = 0;

        for(int i = 0 ; i<array.length; i++){
            int counter = 0;
            for(int j = 0; j<array.length; j++){
                if(array[i]==array[j])
                    counter++;
            }
            if(counter%2 != 0)
                return array[i];
        }

        return null;
    }

    public SomeType findEvenOccurringValue() {

        Arrays.sort(array);
        int nbOccurences = 0;

        for(int i = 0 ; i<array.length; i++){
            int counter = 0;
            for(int j = 0; j<array.length; j++){
                if(array[i]==array[j])
                    counter++;
            }
            if(counter%2 == 0)
                return array[i];
        }
        return null;
    }

    public Integer getNumberOfOccurrences(SomeType valueToEvaluate) {
        int amt = 0;
        for (int i = 0; i < array.length; i++) {
            if (array[i] == valueToEvaluate) {
                amt++;
            }
            else {
                amt = amt;
            }
        }
        return amt;
    }

    public SomeType[] filter(Function<SomeType, Boolean> predicate) {

        return null;
    }
}
